/* CSVSourceConverter.h

Drives conversion from CSV to XML

From Chapter 7 of
Using XML with Legacy Business Applications
Copyright (c) 2002 Addison-Wesley Professional

Author: Michael C. Rawlins
Rawlins EC Consulting
PMB 29
14 Canyon Creek Village
Richardson, TX 75080-1602
mike@rawlinsecconsulting.com
972-783-9573

This file is one of several utilities developed for the book.

All utilities developed for the book are free software; you can
redistribute and/or modify them under the terms of the GNU
General Public License, Version 2, as published by the Free
Software Foundation.

These utilities are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the book; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA

The license is also available on the World Wide Web at
http://www.gnu.org/licenses/gpl.html

*/

#ifndef CSV_SOURCE_CONVERTER_H
#define CSV_SOURCE_CONVERTER_H

class CSVSourceConverter : public SourceConverter
{
public:
  CSVSourceConverter(bool boValidateIn, 
    const char * const cBaseOutputDirectory,
    const char * const cFileDescriptionDocumentName);
  ~CSVSourceConverter();
  int processFile(const char * const cInputFileName);


protected:
  //  XML

  //  Project Classes
  CSVRecordReader * CSVReader;

  //  Basic types
  char Partners[MAX_PARTNERS][CELL_BUFFER_SIZE];
  int iNumPartners;
  int iDocumentBreakColumn;
  int iPartnerBreakColumn;
  char cSavedDocumentID[CELL_BUFFER_SIZE];
  char cSavedPartnerID[CELL_BUFFER_SIZE];
  char cSchemaLocationURL[CELL_BUFFER_SIZE];

private:
  int testDocumentBreak(bool &boDocumentBreak);
  int testPartnerBreak(bool &boPartnerBreak);

};


#endif
