/* FlatRecordReader.h

Handles reading and parsing records in flat files and creating
XML

From Chapter 8 of
Using XML with Legacy Business Applications
Copyright (c) 2002 Addison-Wesley Professional

Author: Michael C. Rawlins
Rawlins EC Consulting
PMB 29
14 Canyon Creek Village
Richardson, TX 75080-1602
mike@rawlinsecconsulting.com
972-783-9573

This file is one of several utilities developed for the book.

All utilities developed for the book are free software; you can
redistribute and/or modify them under the terms of the GNU
General Public License, Version 2, as published by the Free
Software Foundation.

These utilities are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the book; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA

The license is also available on the World Wide Web at
http://www.gnu.org/licenses/gpl.html

*/

#ifndef FLAT_RECORD_READER_H
#define FLAT_RECORD_READER_H

class FlatRecordReader : public RecordReader
{
public:
  FlatRecordReader(const IXMLDOMDocument2Ptr spFileDescription);
  ~FlatRecordReader();
  int getFieldValue(int iOffset, int iInLength,
                    char * cFieldValue);
  int getRecordType(char * const cRecordType);
  int parseRecord(const IXMLDOMElementPtr spRecordGrammar);
  int readRecord();
  int readRecordFixedLength();

protected:
  //  XML Types

  //  IO Streams

  //  Basic Types
  int iFixedRecordLength;
  int iRecordIDFieldOffset;
  int iRecordIDFieldLength;

};

#endif
