/* X12SourceConverter.h

Drives conversion from an X12 interchange to XML - header file
for X12SourceConverter.cpp

From Chapter 9 of
Using XML with Legacy Business Applications
Copyright (c) 2002 Addison-Wesley Professional

Author: Michael C. Rawlins
Rawlins EC Consulting
PMB 29
14 Canyon Creek Village
Richardson, TX 75080-1602
mike@rawlinsecconsulting.com
972-783-9573

This file is one of several utilities developed for the book.

All utilities developed for the book are free software; you can
redistribute and/or modify them under the terms of the GNU
General Public License, Version 2, as published by the Free
Software Foundation.

These utilities are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the book; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA

The license is also available on the World Wide Web at
http://www.gnu.org/licenses/gpl.html

*/

#ifndef X12_SOURCE_CONVERTER_H
#define X12_SOURCE_CONVERTER_H

class X12SourceConverter : public SourceConverter
{
public:
  X12SourceConverter(bool boValidateIn, 
    const char * const cBaseOutputDirectory,
    const char * const cFileDescriptionDocumentName);
  ~X12SourceConverter();
  int processDocument();
  int processFile(const char * const cInputFileName);

protected:
  //  XML

  //  Project Classes
  X12RecordReader * X12Reader;

  //  Basic types

private:
  int writeFunctionalAck();

  char cFDDPath[MAX_PATH_LENGTH];
  char cOutputDirectoryPath[MAX_PATH_LENGTH];
  char cSavedFDDName[MAX_PATH_LENGTH];
  char cGroupSenderID[32];
  char cGroupID[4];
  char cGroupControlNumber[16];
  char cX12Version[32];
  char cIncludedTransactionSets[8];
  int iReceivedTransactionSets;
  char cTag[4];
  char cFAOutputDirectory[MAX_PATH_LENGTH];

};

#endif
