/* X12TargetConverter.h

Header file for X12TargetConverter class

From Chapter 9 of
Using XML with Legacy Business Applications
Copyright (c) 2002 Addison-Wesley Professional

Author: Michael C. Rawlins
Rawlins EC Consulting
PMB 29
14 Canyon Creek Village
Richardson, TX 75080-1602
mike@rawlinsecconsulting.com
972-783-9573

This file is one of several utilities developed for the book.

All utilities developed for the book are free software; you can
redistribute and/or modify them under the terms of the GNU
General Public License, Version 2, as published by the Free
Software Foundation.

These utilities are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the book; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA

The license is also available on the World Wide Web at
http://www.gnu.org/licenses/gpl.html

*/

#ifndef X12_TARGET_CONVERTER_H
#define X12_TARGET_CONVERTER_H

class X12TargetConverter : public TargetConverter
{
public:
  X12TargetConverter(
      const char * const cFileDescriptionDocumentName,
      ofstream * const OutputStream);
  ~X12TargetConverter();
  int processDocument(const IXMLDOMDocument2Ptr spDocInput);
  int writeHeaders();
  int writeTrailers();

protected:
  //  XML

  //  Project Classes
  X12RecordWriter * X12Writer;

  //  Basic types

#endif

};
