/* BlasterIncludes.h

Commonly included header files

From Chapter 6 of
Using XML with Legacy Business Applications
Copyright (c) 2002 Addison-Wesley Professional

Author: Michael C. Rawlins
Rawlins EC Consulting
PMB 29
14 Canyon Creek Village
Richardson, TX 75080-1602
mike@rawlinsecconsulting.com
972-783-9573

This file is one of several utilities developed for the book.

All utilities developed for the book are free software; you can
redistribute and/or modify them under the terms of the GNU
General Public License, Version 2, as published by the Free
Software Foundation.

These utilities are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the book; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA

The license is also available on the World Wide Web at
http://www.gnu.org/licenses/gpl.html

*/

#ifndef BLASTERINCLUDES_H
#define BLASTERINCLUDES_H

// Standard libraries
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>


// MSXML stuff

#import <msxml4.dll>
using namespace MSXML2;

//  Constants for parameter values
#define FAILURE 1
#define SUCCESS 0
#define IO_READ_EOF -1
#define IO_READ_ERROR -2
#define IO_OTHER_ERROR -3

#define CELL_BUFFER_SIZE 1024
#define CELL_ARRAY_SIZE 100
#define MAX_RECORD_SIZE 16584
#define MAX_PATH_LENGTH 128
#define MAX_PARTNERS 32
#define MAX_SEQUENCE_NUMBER 999
#define NMTOKEN_SIZE 128

//  Project base class header files
#include "TextConstants.h"
#include "DataCell.h"
#include "DataCellAN.h"
#include "DataCellDateMMsDDsYYYY.h"
#include "DataCellDateYYYYMMDD.h"
#include "DataCellReal.h"
#include "DataCellN.h"
#include "DataCellX12DT.h"
#include "DataCellX12N.h"
#include "DataCellX12R.h"
#include "DataCellX12TM.h"
#include "RecordHandler.h"
#include "RecordReader.h"
#include "RecordWriter.h"
#include "Converter.h"
#include "SourceConverter.h"
#include "TargetConverter.h"

#endif
